package cn.net.connor.plm.batchRevision;

import java.awt.Frame;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentPseudoFolder;
import com.teamcenter.rac.kernel.TCComponentReleaseStatus;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class BatchRevisionAction extends AbstractAIFAction {

	private AbstractAIFApplication application;
	private TCSession session;
	public BatchRevisionAction(AbstractAIFApplication application, Frame frame, String param) {
		super(application, frame, param);
		this.application = application;
		this.session = (TCSession)application.getSession();
	}

	@Override
	public void run() {
//		MessageBox.post("޶߼", "ҵĴӡϢ", MessageBox.INFORMATION);
		System.out.println("޶ť");
		try {
			for (InterfaceAIFComponent targetComponent : application.getTargetComponents()) {
				String targetName = targetComponent.getProperty("object_string");
				String folderTrueName = null;
				if (targetComponent instanceof TCComponentPseudoFolder) {
					TCComponentPseudoFolder folder = (TCComponentPseudoFolder)targetComponent;
					//ѡļڵİ汾
					TCComponentItemRevision owningRevision = (TCComponentItemRevision)folder.getOwningComponent();

					String folderName = folder.getStringProperty("object_string");
					System.out.println("ѡļеʾ="+folderName+"-"+folder.getType());
					if (folderName != null && folderName.equals("")) {
						folderTrueName = "CMHasProblemItem";
						
					}else if (folderName != null && folderName.equals("Ӱ")) {
						folderTrueName = "CMHasImpactedItem";
					}
					System.out.println("ѡļжӦʵ="+folderTrueName);
					
					if (folderTrueName != null) {
						//ȡѡļڵĶ -referenceListProperty
						TCComponent[] referenceListProperty = owningRevision.getReferenceListProperty(folderTrueName);
						if (referenceListProperty != null && referenceListProperty.length > 0) {
							
//							session.getUserService().call("bypass", new Object[] { true });
							String xdErroItemRevString = "";//δ޶ʧܵİ汾Ϣûзָ
							//ѡļµĶ棬°ŵ-CMHasSolutionItem 
							for (int i = 0; i < referenceListProperty.length; i++) {
								TCComponentItemRevision rev = (TCComponentItemRevision)referenceListProperty[i];
								TCComponentItem item = rev.getItem();
								//жϸð汾Ƿѷδ޷޶
								if (!isRelease(rev)) {
									System.out.println(">>>汾"+rev.getStringProperty("object_string")+"δ޶");
									xdErroItemRevString += "	"+rev.getStringProperty("object_string")+"\n";
									continue;
								}else {
									//汾ѷ棬ļ
									try {
										TCComponentItemRevision newItemRevision = rev.saveAs(null);
										owningRevision.add("CMHasSolutionItem", newItemRevision);
									} catch (Exception e) {
										try {
											TCComponentItemRevision latestItemRevision = rev.getItem().getLatestItemRevision();
											owningRevision.add("CMHasSolutionItem", latestItemRevision);
											System.out.println("Ѵ°汾");
										}catch  (Exception e2) {
											e2.printStackTrace();
										}

									}
								}
							}
//							session.getUserService().call("bypass", new Object[] { false });
							System.out.println("޶ɣ");
							if (xdErroItemRevString != null && !xdErroItemRevString.equals("")){
								MessageBox.post("޶ɣ\nְ汾޶ʧܡԭδ\n	"+xdErroItemRevString, "ҵĴӡϢ", MessageBox.INFORMATION);
							}else {
								MessageBox.post("޶ɣ", "޶", MessageBox.INFORMATION);
							}
							
							
							
							
							
							
							
							
							
						}else {
							System.out.println("δȡļ["+folderName+"-"+folderTrueName+"]µ");
							MessageBox.post("δȡļ["+folderName+"-"+folderTrueName+"]µ", "޶", MessageBox.INFORMATION);
						}
						
					}else {
						System.out.println("ȡѡļеʵֵʧܣ");
					}
					
				}else {
					System.out.println("ѡж"+targetName+" [ļ] Ϊ"+targetComponent.getType());
				}
			}
			
		} catch (Exception e) {
			System.out.println("޶ʧܣ");
			e.printStackTrace();
		}
	}

	/**
	 * жϰ汾Ƿѷ
	 * @param rev
	 * @return
	 * @throws TCException 
	 */
	private boolean isRelease(TCComponentItemRevision rev) throws TCException {
		AIFComponentContext[] releaseList = rev.getChildren("release_status_list");
		if (releaseList != null && releaseList.length > 0) {
			TCComponentReleaseStatus status = (TCComponentReleaseStatus) releaseList[releaseList.length-1].getComponent();
			String releaseName = status.getProperty("name");
			if (!releaseName.contains("")||!releaseName.contains("TCM")) {
				return false;
			}else {
				return true;
			}
		}else {
			return false;
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
