package com.connor.plm;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ChangeRequestTypeSelectDialog extends JDialog {
    private String selectedValue = null;

    // ̬ʾԻ򲢷ѡеֵ
    public static String showComboBoxDialog(Component parent, String title, String labelText, String[] options) {
        // һģʽ JDialog
        ChangeRequestTypeSelectDialog dialog = new ChangeRequestTypeSelectDialog(parent, title, labelText, options);
        dialog.setVisible(true); // ʾԻִ
        return dialog.selectedValue; // ûѡֵ
    }

    // ˽й캯
    private ChangeRequestTypeSelectDialog(Component parent, String title, String labelText, String[] options) {
        super(JOptionPane.getFrameForComponent(parent), title, true); // ģʽԻ

        // ʼ
        JLabel label = new JLabel(labelText + ":");
        comboBox = new JComboBox<>(options);
        cancelButton = new JButton("ȡ");
        confirmButton = new JButton("ȷ");

        // ò
        JPanel panel = new JPanel();
        panel.setLayout(new FlowLayout(FlowLayout.CENTER));

        panel.add(label);
        panel.add(comboBox);

        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
        buttonPanel.add(cancelButton);
        buttonPanel.add(confirmButton);

        this.add(panel, BorderLayout.CENTER);
        this.add(buttonPanel, BorderLayout.SOUTH);

        // ¼
        confirmButton.addActionListener(e -> {
            selectedValue = (String) comboBox.getSelectedItem();
            dispose(); // رնԻ
        });

        cancelButton.addActionListener(e -> {
            selectedValue = null;
            dispose(); // رնԻ
        });

        // ô
        this.setSize(400, 150);
        this.setLocationRelativeTo(parent); // ʾ
        this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    }

    private JComboBox<String> comboBox;
    private JButton cancelButton, confirmButton;

}
