package com.connor.plm;

import java.lang.reflect.Constructor;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.util.MessageBox;


public class KAction extends AbstractAIFAction {


	KAction(AbstractAIFUIApplication app, String string) {
		super(app,string);
	}

	@Override
	public void run() {
		try {
			int ind = actionName.indexOf('#');
			String action=actionName;
			String actionData="";
			if(ind>0) {
				action=actionName.substring(0,ind);//actionNameУ#ǰ
				actionData=actionName.substring(ind+1);//actionNameУ#ź
			}
			Class<?> c = Class.forName(action);
			Constructor<?> constructor = c.getConstructor(AbstractAIFApplication.class, String.class,String.class);
			KCommand command = (KCommand) constructor.newInstance(this.application, action, actionData);
			command.executeModal();
		} catch (Exception e) {
			e.printStackTrace();
			MessageBox.post(e.toString(),KLocale.getString("error"),MessageBox.ERROR);
		} 
	}
}
