package cn.net.connor.designtopart.designtopart;

import java.awt.BorderLayout;
import java.awt.Dimension;

import cn.net.connor.designtopart.DesigntopartLocale;
import javafx.embed.swing.JFXPanel;
import k.KDialog;
import k.KDialogController;

@SuppressWarnings("serial")
public class DesignToPartDialog extends KDialog {

	protected DesignToPartDialogController controller;

	public DesignToPartDialog(KDialogController controller) {
		super(controller);
		this.controller = (DesignToPartDialogController) controller;
	}

	@Override
	protected void addListeners() {
	}

	@Override
	protected void initUI() {
		this.setTitle(DesigntopartLocale.getString("designtopart"));
		this.setPreferredSize(new Dimension(800, 600));
		this.setMinimumSize(new Dimension(800, 600));
		JFXPanel panel = new JFXPanel();
		panel.setScene(new DesignToPartPanel(this).getScene());
		this.add(BorderLayout.CENTER, panel);
	}

}
