package com.connor.dfl.plm.util;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Map;

import com.teamcenter.rac.util.MessageBox;

public class DataBaseControl {

	/** ************************ݿ:*********************************** */
	/**
	 * kelsen ....
	 */
	Connection conn;

	ResultSet rs;

	PreparedStatement pstmt;

	Statement stmt;

	String strSQLQuery;

	public String str_Information = "";

	private String strDriver = "oracle.jdbc.driver.OracleDriver";
	private String strUrl = "jdbc:oracle:thin:@localhost:1521:tc12";
//	private String strUrl = "jdbc:oracle:thin:@192.168.3.22:1521:tc12";
	private String strUserName = "infodba";
	private String strPassword = "infodba";

	public DataBaseControl(String strDriver, String strUrl, String strUserName, String strPassword) {
		this.strDriver = strDriver;
		this.strUrl = strUrl;
		this.strUserName = strUserName;
		this.strPassword = strPassword;
		try {
			Class.forName(strDriver);
		} catch (ClassNotFoundException cnfe) {
			cnfe.printStackTrace();
		}
	}

	/**
	 * ѯ2
	 */
	public ResultSet dbQuery2(String strSQLQuery, Object[] strs) {
		ResultSet rs_result = null;
		if (conn == null)
			openDataBase();
		try {
			// stmt = conn.createStatement();
			PreparedStatement ps = conn.prepareStatement(strSQLQuery);
			for (int i = 0; i < strs.length; i++) {
				ps.setObject(i + 1, strs[i]);
			}
			rs_result = ps.executeQuery();

		} catch (SQLException sqle2) {
			sqle2.printStackTrace();
		}
		return rs_result;
	}

	/**
	 * 2
	 */
	public void dbModify2(String strSQLQuery, Object[] strs) {
		try {
			PreparedStatement ps = conn.prepareStatement(strSQLQuery);
			for (int i = 0; i < strs.length; i++) {
				ps.setObject(i + 1, strs[i]);
			}
			ps.executeUpdate();

		} catch (SQLException sqle2) {
			sqle2.printStackTrace();
		}
	}

	/**
	 * 
	 * 
	 */
	public void openDataBase() {
		try {
			if (conn == null || conn.isClosed()) {
				conn = DriverManager.getConnection(this.strUrl, this.strUserName, this.strPassword);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	/**
	 * رݿ
	 */
	public void closeDataBase() {
		try {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException sqlec) {
					sqlec.printStackTrace();
				}
			}
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException sqlec) {
					sqlec.printStackTrace();
				}
			}
			if (conn != null && !conn.isClosed()) {
				try {
					conn.close();
				} catch (SQLException sqlecon) {
					sqlecon.printStackTrace();
				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * ˮ
	 * 
	 * @param type   ˮ
	 * @param prefix ǰ׺
	 * @param col    ˮλ 4λ"0000"
	 * @return
	 * @throws Exception
	 */
	public String getNewCode(String type, String col) throws Exception {
		openDataBase();
		String lshstr = "";
		if (col != null && !"".equals(col)) {
			lshstr = col;
		} else {
			lshstr = "00000000000";
		}
		openDataBase();
		// ͼֽͲѯ ǰ׺ ˮ
		String query = "select TYPE,PREFIX,LSH from XINSHIBAO where TYPE= ?";
		String query2 = "select LSH from XINSHIBAO where PREFIX = ? ";
		String query3 = "select LSH from XINSHIBAO where PREFIX = ? and LSH is not null order by LSH DESC";

		ResultSet rs = dbQuery2(query, new Object[] { type });
		if (rs.next()) {
			String t = rs.getString(1);
			String pre = rs.getString(2);
			String lsh = rs.getString(3);

			if (pre == null || "".equals(pre) || "null".equals(pre)) {
				return "δǰ׺޷ERP";
			}
			ResultSet rs2 = dbQuery2(query2, new Object[] { pre });
			boolean flag = rs2.next();
			if (flag) {
				lsh = rs2.getString(1);
				if (lsh == null || "null".equals(lsh) || "".equals(lsh)) {
					int temp = col.length() - pre.length();
					lsh = pre;
					while (temp > 0) {
						lsh += "0";
						temp--;
					}
				} else {
					ResultSet rs3 = dbQuery2(query3, new Object[] { pre });
					rs3.next();
					lsh = rs3.getString(1);
				}
			}
			long ls = Long.parseLong(lsh) + 1;// µˮ
			lshstr = ls + "";
			String upin = "update XINSHIBAO set LSH = ?  where TYPE = ? ";
			dbModify2(upin, new Object[] { lshstr, t });
		}
		closeDataBase();
		return lshstr;

	}

	public String getNewCode(String prefix, String min, String max) throws Exception {
		openDataBase();
		String lshstr = "";
		String query = "SELECT LSH FROM SHIBAO_LSH WHERE PREFIX = ? AND LSHMIN = ?";
		ResultSet rs = dbQuery2(query, new Object[] { prefix, min });
		if (rs.next()) {
			String lsh = rs.getString(1);
			long parseLong = Long.parseLong(lsh) + 1;
			if (parseLong > Long.parseLong(max)) {
				return "";
			}
			lshstr = parseLong + "";
			if (lshstr.length() < max.length()) {
				int temp = max.length() - lshstr.length();
				while (temp > 0) {
					lshstr = "0" + lshstr;
					temp--;
				}
			}
			String update = "UPDATE SHIBAO_LSH SET LSH = ? WHERE PREFIX = ? AND LSHMIN = ?";
			dbModify2(update, new Object[] { lshstr, prefix, min });
		} else {
			lshstr = min;
			String update = "INSERT INTO SHIBAO_LSH(PREFIX,LSH,LSHMIN) VALUES(?,?,?)";
			dbModify2(update, new Object[] { prefix, min, min });
		}
		closeDataBase();
		return lshstr;
	}

	public static void main(String args[]) {
		try {
//			String strDriver = "oracle.jdbc.driver.OracleDriver";
//			String strUrl = "jdbc:oracle:thin:@localhost:1521:tc12";
//			String strUserName = "infodba";
//			String strPassword = "infodba";
//
//			DataBaseControl dbc = new DataBaseControl(strDriver, strUrl, strUserName, strPassword);
//			dbc.openDataBase();
//			String newid = dbc.getNewCode("1123456746", "01", "55");
//			System.out.println(newid);
//			dbc.closeDataBase();

//			String min = "099";
//			String max = "999";
//			String lsh = "";
//			long parseLong = Long.parseLong(min)+1;
//			System.out.println(parseLong);
//			lsh = parseLong + "";
//			if (lsh.length() < max.length()) {
//				int temp = max.length() - lsh.length();
//				while (temp > 0) {
//					lsh = "0" +lsh;
//					temp--;
//				}
//			}
//			System.out.println(lsh);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
