package com.connor.plm.sb02;

import java.util.ArrayList;

import com.connor.plm.KCommand;
import com.connor.plm.KUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class DerivedChangeOptionCommand extends KCommand {
	public DerivedChangeOptionCommand(AbstractAIFApplication app, String commandId, String actionInfo) {
		super(app, commandId, actionInfo);
		TCSession session = (TCSession) app.getSession();
		String preName = "Connor_Derive_CO";
		try {
			String[] prefVals = KUtil.getPrefVals(session, preName);
			InterfaceAIFComponent targetComponent = app.getTargetComponent();
			StringBuffer newType = new StringBuffer();
			if (prefVals == null) {
				MessageBox.post(preName + "ѡδ", "ʾ", MessageBox.INFORMATION);
				return;
			}
			ArrayList<ControlBean> beanList = new ArrayList<ControlBean>();
			KUtil.dealPref(prefVals, targetComponent, beanList, newType);
			for (ControlBean bean : beanList) {
				System.out.println("beanList" + bean.toString());
			}
			if (newType.toString().isEmpty()) {
//				MessageBox.post(preName + "ѡ󣬲½Ķ", "ʾ", MessageBox.INFORMATION);
				System.out.println("ȡ½ĶʧܣȡѡԴѣ");
				return;
			}
			if (beanList.size() == 0) {
				MessageBox.post(preName + "ѡ󣬲ѡж͵", "ʾ", MessageBox.INFORMATION);
				return;
			}
			this.setRunnable(
					new DerivedChangeRequestDialog(app, beanList, newType, (TCComponentItemRevision) targetComponent));

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
